#!/usr/bin/perl

# ARCADEmini converter: blm2amasm
# version 1.0 date 2003-11-02
# part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
# written by 1stein <1stein@schuermans.info>
# based on blinkenplayer.pl by stray <stray@stray.ch>
# Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

print <<EOF;
ARCADEmini converter: blm2amasm
version 1.0 date 2003-11-02
part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
written by 1stein <1stein\@schuermans.info>
based on blinkenplayer.pl by stray <stray\@stray.ch>
Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

EOF

if( @ARGV < 1 )
{
	print <<EOF;
syntax: blm2amasm <blm-file> [<amasm-file>]

examples: blm2amasm example.blm
          blm2amasm example.blm example.amasm

EOF
	exit;
}

read_source( $ARGV[0] );

if( @ARGV < 2 ) { $file = $ARGV[0] . ".amasm"; } else { $file = $ARGV[1]; }
open( F, "> " . $file ) || die "Can't open output file \"$file\": $!\n";

$char[0] = " ";
$char[1] = "#";

for( $f = 0; $f <= $#del; $f++) {

	$chars = @{@{$frames[$f]}[0]};
	if( $chars > 26 ) { $chars = 26 };
	$lines = @{$frames[$f]};
	if( $lines > 20 ) { $lines = 20 };
	$left = (26 - $chars) / 2;
	$right = 26 - $chars - $left;
	$top = (20 - $lines) / 2;
	$bottom = 20 - $lines - $top;

	$bit = 0;
	for( $i = 0; $i < 26 * $top; $i++, $bit++ ) { @bits[$bit] = 0; }
	$linenum = 0;
	foreach (@{$frames[$f]}) {
	  if( $linenum < 26 ) { for( $i = 0; $i < $left; $i++, $bit++ ) { @bits[$bit] = 0; } }
	  $charnum = 0;
	  foreach (@$_) {
		print($char[$_]);
		if( $linenum < 20 && $charnum < 26 ) {
		  @bits[$bit] = $_;
		  $bit++;
		}
		$charnum++;
	  }
	  if( $linenum < 26 ) { for( $i = 0; $i < $right; $i++, $bit++ ) { @bits[$bit] = 0; } }
	  print("\n");
	  $linenum++;
	}
	for( $i = 0; $i < 26 * $bottom; $i++, $bit++ ) { @bits[$bit] = 0; }

	print F "                WR_PIX_BW       ";
	for( $byte = 0; $byte < 65; $byte++ ) {
		$val = 0;
		for( $bit = 0; $bit < 8; $bit++ ) {
			$val = $val * 2 + @bits[$byte*8+$bit];
		}
                if( $byte % 8 == 7 ) { print F $val . ",\n                                "; }
                else { if( $byte == 64 ) { print F $val . ";\n"; } else { print F $val . ", "; } }
	}
        print F "                DISPLAY;\n";

        print F "                DELAY_DO        " . $del[$f] . ";\n";
}

close F;

sub read_source {
  my $file = shift;
  open (F, $file) || die "Can't open input file \"$file\": $!\n";
  foreach $line (<F>) {
	chomp $line; chomp $line;
	$line =~ s/#.*//;
	next unless $line =~ /\S+/;
	if ($line =~ /^\@(\d+)/) {
	  push(@del,$1);
	  $frame = $#del;
	  next;
	}
	push(@{$frames[$frame]}, [split(undef,$line)]); 
  }
  close F;
}

